import java.util.*;
import java.io.*;


public class SplitDictionary { 
    static final int MAX_PART_SIZE = 16*1024;
    
    static final String OUT_DIR = "..\\res\\";

    public static void main(String[] args) throws Exception {
	BufferedReader in = new BufferedReader(new FileReader("Mueller7GPL.win"));
	String line;
        String prevWord = null;
        StringBuffer ib = new StringBuffer();
        int size = 0;
        int totalSize = 0;
	FileOutputStream index = new FileOutputStream(OUT_DIR + "dictionary.idx");
	FileOutputStream out = new FileOutputStream(OUT_DIR + "volume.1");
        int id = 1;
        int n = 0;

	while ((line = in.readLine()) != null) { 
            int i = line.indexOf("  ");
            if (i <= 0 || line.charAt(0) < 'A' || line.charAt(0) > 'z') {
                continue;
            }
            String eng = line.substring(0, i).trim().toLowerCase();
            String rus = line.substring(i+2);
            int transStart = rus.indexOf('[');
            int transEnd = rus.indexOf(']');
            if (transStart >= 0 && transEnd > transStart) { 
                rus = rus.substring(0, transStart) + rus.substring(transEnd+1);
            }
            rus = rus.trim();
            if (rus.length() == 0) { 
                continue;
            }
            StringBuffer sb = new StringBuffer();
            if (prevWord == null) { 
                ib.append(eng);
                ib.append(':');
                sb.append(eng);
            } else { 
                int prefix;
                int len = eng.length() > prevWord.length() ? prevWord.length() : eng.length();
                if (len > 9) { 
                    len = 9;
                }
                for (prefix = 0; prefix < len && eng.charAt(prefix) == prevWord.charAt(prefix); prefix++);
                if (prefix > 0) { 
                    sb.append((char)(prefix + '0'));
                    sb.append(eng.substring(prefix));
                } else { 
                    sb.append(eng);
                }
            }
            sb.append(':');
            sb.append(rus);
            sb.append('\n');
            byte[] bytes = sb.toString().getBytes();
            if (size + bytes.length > MAX_PART_SIZE) { 
                ib.append(prevWord);
                ib.append('\n');
                index.write(ib.toString().getBytes());
                ib = new StringBuffer();
                ib.append(eng);
                ib.append(':');
                out.close();
                out = new FileOutputStream(OUT_DIR + "volume." + ++id);
                size = 0;
            }
            size += bytes.length;
            totalSize += bytes.length;
            n += 1;
            prevWord = eng;
            out.write(bytes);
        }
	out.close();
        ib.append(prevWord);
        ib.append('\n');
        index.write(ib.toString().getBytes());
        index.close();
	System.out.println("Words " + n + ", size " + totalSize);
    }
}